Index: /trunk/anuga_core/source/anuga/shallow_water/boundaries.py
===================================================================
--- /trunk/anuga_core/source/anuga/shallow_water/boundaries.py	(revision 9173)
+++ /trunk/anuga_core/source/anuga/shallow_water/boundaries.py	(revision 9174)
@@ -346,4 +346,163 @@
         q[1] = q[2] = 0.0
         return q
+
+class Characteristic_stage_boundary(Boundary):
+    """Sets the stage via a function and the momentum is determined 
+    via assumption of simple incoming wave (uses Riemann invariant)
+
+
+    Example:
+
+    def waveform(t):
+        return sea_level + normalized_amplitude/cosh(t-25)**2
+
+    Bcs = Characteristic_stage_boundary(domain, waveform)
+
+    Underlying domain must be specified when boundary is instantiated
+    """
+
+    def __init__(self, domain=None, function=None, default_stage = 0.0):
+        """ Instantiate a
+            Characteristic_stage_boundary.
+            domain is the domain containing the boundary
+            function is the function to apply the wave
+            default_stage is the assumed stage pre the application of wave
+        """
+
+        Boundary.__init__(self)
+
+        if domain is None:
+            msg = 'Domain must be specified for this type boundary'
+            raise Exception, msg
+
+        if function is None:
+            msg = 'Function must be specified for this type boundary'
+            raise Exception, msg
+
+        self.domain = domain
+        self.function = function
+        self.default_stage = default_stage
+
+        self.Elev  = domain.quantitis['elevation']
+        self.Stage = domain.quantitis['stage']
+        self.Height = domain.quantitis['height']
+
+    def __repr__(self):
+        """ Return a representation of this instance. """
+        msg = 'Characteristic_stage_boundary '
+        msg += '(%s) ' % self.domain
+        msg += '(%s) ' % self.default_stage
+        return msg
+
+
+    def evaluate(self, vol_id, edge_id):
+        """Calculate reflections (reverse outward momentum).
+
+        vol_id   
+        edge_id  
+        """
+        
+        t = self.domain.get_time()
+
+
+        value = self.function(t)
+        try:
+            stage = float(value)
+        except:
+            stage = float(value[0])
+
+
+
+        q = self.conserved_quantities
+        #q[0] = self.stage[vol_id, edge_id]
+        q[0] = stage
+        q[1] = self.xmom[vol_id, edge_id]
+        q[2] = self.ymom[vol_id, edge_id]
+
+        normal = self.normals[vol_id, 2*edge_id:2*edge_id+2]
+
+        r = rotate(q, normal, direction = 1)
+        r[1] = -r[1]
+        q = rotate(r, normal, direction = -1)
+
+
+        return q
+
+
+
+
+
+
+    def evaluate_segment(self, domain, segment_edges):
+        """Apply reflective BC on the boundary edges defined by
+        segment_edges
+        """
+
+        if segment_edges is None:
+            return
+        if domain is None:
+            return
+
+        t = self.domain.get_time()
+
+
+        value = self.function(t)
+        try:
+            stage = float(value)
+        except:
+            stage = float(value[0])
+                       
+
+        ids = segment_edges
+        vol_ids  = domain.boundary_cells[ids]
+        edge_ids = domain.boundary_edges[ids]
+
+        Stage = domain.quantities['stage']
+        Elev  = domain.quantities['elevation']
+        Height= domain.quantities['height']
+        Xmom  = domain.quantities['xmomentum']
+        Ymom  = domain.quantities['ymomentum']
+        Xvel  = domain.quantities['xvelocity']
+        Yvel  = domain.quantities['yvelocity']
+
+        Normals = domain.normals
+
+        #print vol_ids
+        #print edge_ids
+        #Normals.reshape((4,3,2))
+        #print Normals.shape
+        #print Normals[vol_ids, 2*edge_ids]
+        #print Normals[vol_ids, 2*edge_ids+1]
+        
+        n1  = Normals[vol_ids,2*edge_ids]
+        n2  = Normals[vol_ids,2*edge_ids+1]
+
+        # Transfer these quantities to the boundary array
+        Stage.boundary_values[ids]  = Stage.edge_values[vol_ids,edge_ids]
+        Elev.boundary_values[ids]   = Elev.edge_values[vol_ids,edge_ids]
+        Height.boundary_values[ids] = Height.edge_values[vol_ids,edge_ids]
+
+        # Rotate and negate Momemtum
+        q1 = Xmom.edge_values[vol_ids,edge_ids]
+        q2 = Ymom.edge_values[vol_ids,edge_ids]
+
+        r1 = -q1*n1 - q2*n2
+        r2 = -q1*n2 + q2*n1
+
+        Xmom.boundary_values[ids] = n1*r1 - n2*r2
+        Ymom.boundary_values[ids] = n2*r1 + n1*r2
+
+        # Rotate and negate Velocity
+        q1 = Xvel.edge_values[vol_ids,edge_ids]
+        q2 = Yvel.edge_values[vol_ids,edge_ids]
+
+        r1 = q1*n1 + q2*n2
+        r2 = q1*n2 - q2*n1
+
+        Xvel.boundary_values[ids] = n1*r1 - n2*r2
+        Yvel.boundary_values[ids] = n2*r1 + n1*r2
+
+        
+
 
 class Dirichlet_discharge_boundary(Boundary):
Index: /trunk/anuga_core/source/anuga/shallow_water/test_swb2_domain.py
===================================================================
--- /trunk/anuga_core/source/anuga/shallow_water/test_swb2_domain.py	(revision 9173)
+++ /trunk/anuga_core/source/anuga/shallow_water/test_swb2_domain.py	(revision 9174)
@@ -36,6 +36,6 @@
 
         domain=Domain(points,vertices,boundary)    # Create Domain
-        domain.set_flow_algorithm('tsunami')
-
+        domain.set_flow_algorithm('DE0')
+        
         domain.set_name('runup_sinusoid_v2')                         # Output to file runup.sww
         domain.set_datadir('.')                          # Use current folder
@@ -91,4 +91,5 @@
 
 
+        print vv.max()
 
         assert num.all(vv<1.0e-02)
Index: /trunk/anuga_core/source/anuga_parallel/distribute_mesh.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/distribute_mesh.py	(revision 9173)
+++ /trunk/anuga_core/source/anuga_parallel/distribute_mesh.py	(revision 9174)
@@ -645,42 +645,4 @@
 
 
-    #print ghosttri
-
-    # FIXME SR: For larger layers need to pass through the correct
-    # boundary tag!
-
-#    for t in ghosttri:
-#        ghost_list.append(t[0])
-#
-#
-#
-#    for t in ghosttri:
-#
-#        n = mesh.neighbours[t[0], 0]
-#        if not is_in_processor(ghost_list, tlower, tupper, n):
-#            if boundary.has_key( (t[0], 0) ):
-#                subboundary[t[0], 0] = boundary[t[0],0]
-#            else:
-#                subboundary[t[0], 0] = 'ghost'
-#
-#
-#        n = mesh.neighbours[t[0], 1]
-#        if not is_in_processor(ghost_list, tlower, tupper, n):
-#            if boundary.has_key( (t[0], 1) ):
-#                subboundary[t[0], 1] = boundary[t[0],1]
-#            else:
-#                subboundary[t[0], 1] = 'ghost'
-#
-#
-#        n = mesh.neighbours[t[0], 2]
-#        if not is_in_processor(ghost_list, tlower, tupper, n):
-#            if boundary.has_key( (t[0], 2) ):
-#                subboundary[t[0], 2] = boundary[t[0],2]
-#            else:
-#                subboundary[t[0], 2] = 'ghost'
-#
-
-
-
     new_ghost_list = ghosttri[:,0]
 
@@ -707,5 +669,5 @@
     values1 = ['ghost']*n1
 
-    # 1 edge boundary
+    # 2 edge boundary
     nghb2 = mesh.neighbours[new_ghost_list,2]
     gl2 = num.extract(num.logical_or(nghb2 < tlower, nghb2 >= tupper), new_ghost_list)
@@ -1278,6 +1240,10 @@
 
 
+
+    tri_l2g  = extract_l2g_map(tri_map)
+    node_l2g = extract_l2g_map(node_map)
+     
     return GAnodes, GAtriangles, GAboundary, quantities, ghost_rec, \
-           full_send, tri_map, node_map, ghost_layer_width
+           full_send, tri_map, node_map, tri_l2g, node_l2g, ghost_layer_width
 
 
@@ -1615,21 +1581,13 @@
 
     [GAnodes, GAtriangles, boundary, quantities, \
-     ghost_rec, full_send, tri_map, node_map, ghost_layer_width] = \
-              build_local_mesh(submesh_cell, lower_t, upper_t, \
-                               numproc)
+     ghost_rec, full_send, \
+     tri_map, node_map, tri_l2g, node_l2g, \
+     ghost_layer_width] = \
+     build_local_mesh(submesh_cell, lower_t, upper_t, numproc)
     
     return GAnodes, GAtriangles, boundary, quantities,\
            ghost_rec, full_send,\
            number_of_full_nodes, number_of_full_triangles, tri_map, node_map,\
-           ghost_layer_width
-
-
-
-
-
-
-
-
-
+           tri_l2g, node_l2g, ghost_layer_width
 
 
@@ -1651,5 +1609,5 @@
 #
 #########################################################
-def extract_submesh(submesh, triangles_per_proc, p=0):
+def extract_submesh(submesh, triangles_per_proc, p2s_map=None, p=0):
 
     
@@ -1679,13 +1637,42 @@
     numprocs = len(triangles_per_proc)
     points, vertices, boundary, quantities, ghost_recv_dict, \
-            full_send_dict, tri_map, node_map, ghost_layer_width = \
+            full_send_dict, tri_map, node_map, tri_l2g, node_l2g, \
+            ghost_layer_width = \
             build_local_mesh(submesh_cell, lower_t, upper_t, numprocs)
 
+    if p2s_map is None:
+        pass
+    else:
+        tri_l2g = p2s_map[tri_l2g]
 
     return  points, vertices, boundary, quantities, ghost_recv_dict, \
-           full_send_dict, tri_map, node_map, ghost_layer_width
+           full_send_dict, tri_map, node_map, tri_l2g, node_l2g, ghost_layer_width
            
 
 
-
-
+def extract_l2g_map(map):
+    # Extract l2g data  from corresponding map
+    # Maps
+
+    import numpy as num
+
+    b = num.arange(len(map))
+
+    l_ids = num.extract(map>-1,map)
+    g_ids = num.extract(map>-1,b)
+
+
+#    print len(g_ids)
+#    print len(l_ids)
+#    print l_ids
+#    print g_ids
+
+    l2g = num.zeros_like(g_ids)
+    l2g[l_ids] = g_ids
+
+    return l2g
+
+
+
+
+
Index: /trunk/anuga_core/source/anuga_parallel/parallel_api.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/parallel_api.py	(revision 9173)
+++ /trunk/anuga_core/source/anuga_parallel/parallel_api.py	(revision 9174)
@@ -37,6 +37,79 @@
 
 
-
 def distribute(domain, verbose=False, debug=False, parameters = None):
+    """ Distribute the domain to all processes
+
+    parameters allows user to change size of ghost layer
+    """
+
+    if not pypar_available or numprocs == 1 : return domain # Bypass
+
+        
+    if myid == 0:
+        from sequential_distribute import Sequential_distribute
+        partition = Sequential_distribute(domain, verbose, debug, parameters)
+
+        partition.distribute(numprocs)
+
+        kwargs, points, vertices, boundary, quantities, boundary_map, \
+                domain_name, domain_dir, domain_store, domain_store_centroids, \
+                domain_minimum_storable_height, domain_minimum_allowed_height, \
+                domain_flow_algorithm, georef = partition.extract_submesh(0)
+        
+        for p in range(1, numprocs):
+
+            tostore = partition.extract_submesh(p)
+
+            send(tostore,p)
+
+    else:
+
+        kwargs, points, vertices, boundary, quantities, boundary_map, \
+                       domain_name, domain_dir, domain_store, domain_store_centroids, \
+                       domain_minimum_storable_height, domain_minimum_allowed_height, \
+                       domain_flow_algorithm, georef = receive(0)
+
+    #---------------------------------------------------------------------------
+    # Now Create parallel domain
+    #---------------------------------------------------------------------------
+    parallel_domain = Parallel_domain(points, vertices, boundary, **kwargs)
+
+
+    #------------------------------------------------------------------------
+    # Copy in quantity data
+    #------------------------------------------------------------------------
+    for q in quantities:
+        parallel_domain.set_quantity(q, quantities[q])
+
+
+    #------------------------------------------------------------------------
+    # Transfer boundary conditions to each subdomain
+    #------------------------------------------------------------------------
+    boundary_map['ghost'] = None  # Add binding to ghost boundary
+    parallel_domain.set_boundary(boundary_map)
+
+
+    #------------------------------------------------------------------------
+    # Transfer other attributes to each subdomain
+    #------------------------------------------------------------------------
+    parallel_domain.set_name(domain_name)
+    parallel_domain.set_datadir(domain_dir)
+    parallel_domain.set_store(domain_store)
+    parallel_domain.set_store_centroids(domain_store_centroids)
+    parallel_domain.set_minimum_storable_height(domain_minimum_storable_height)
+    parallel_domain.set_minimum_allowed_height(domain_minimum_allowed_height)
+    parallel_domain.set_flow_algorithm(domain_flow_algorithm)
+    parallel_domain.geo_reference = georef
+
+
+    return parallel_domain
+
+
+        
+        
+
+
+
+def old_distribute(domain, verbose=False, debug=False, parameters = None):
     """ Distribute the domain to all processes
 
@@ -125,11 +198,13 @@
                 ghost_recv_dict, full_send_dict,\
                 number_of_full_nodes, number_of_full_triangles,\
-                s2p_map, p2s_map, tri_map, node_map, ghost_layer_width =\
+                s2p_map, p2s_map, tri_map, node_map, tri_l2g, node_l2g, \
+                ghost_layer_width =\
                 distribute_mesh(domain, verbose=verbose, debug=debug, parameters=parameters)
             
         # Extract l2g maps
-        tri_l2g  = extract_l2g_map(tri_map)
-        node_l2g = extract_l2g_map(node_map)
-
+        #tri_l2g  = extract_l2g_map(tri_map)
+        #node_l2g = extract_l2g_map(node_map)
+        #tri_l2g = p2s_map[tri_l2g]
+        
         if debug:
             print 'P%d' %myid
@@ -183,5 +258,5 @@
                 ghost_recv_dict, full_send_dict,\
                 number_of_full_nodes, number_of_full_triangles, \
-                tri_map, node_map, ghost_layer_width =\
+                tri_map, node_map, tri_l2g, node_l2g, ghost_layer_width =\
                 rec_submesh(0, verbose)
 
@@ -189,8 +264,9 @@
 
         # Extract l2g maps
-        tri_l2g  = extract_l2g_map(tri_map)
-        node_l2g = extract_l2g_map(node_map)
-        
-        # Recieve serial to parallel (s2p) and parallel to serial (p2s) triangle mapping
+        #tri_l2g  = extract_l2g_map(tri_map)
+        #node_l2g = extract_l2g_map(node_map)
+        #tri_l2g = p2s_map[tri_l2g]
+        
+        # Receive serial to parallel (s2p) and parallel to serial (p2s) triangle mapping
         if send_s2p :
             s2p_map_flat = receive(0)
@@ -264,5 +340,10 @@
 
 def distribute_mesh(domain, verbose=False, debug=False, parameters=None):
-
+    """ Distribute andsend the mesh info to all the processors.
+    Should only be run from processor 0 and will send info to the other
+    processors.
+    There should be a corresponding  rec_submesh called from all the other
+    processors
+    """
 
     if debug:
@@ -303,11 +384,14 @@
     if verbose: print 'Distribute submeshes'        
     for p in range(1, numprocs):
-        send_submesh(submesh, triangles_per_proc, p, verbose)
+        send_submesh(submesh, triangles_per_proc, p2s_map, p, verbose)
 
     # Build the local mesh for processor 0
     points, vertices, boundary, quantities, \
-            ghost_recv_dict, full_send_dict, tri_map, node_map, ghost_layer_width =\
-              extract_submesh(submesh, triangles_per_proc,0)
-
+            ghost_recv_dict, full_send_dict, \
+            tri_map, node_map, tri_l2g, node_l2g, ghost_layer_width =\
+              extract_submesh(submesh, triangles_per_proc, p2s_map, 0)
+
+
+              
     # Keep track of the number full nodes and triangles.
     # This is useful later if one needs access to a ghost-free domain
@@ -344,28 +428,29 @@
            ghost_recv_dict, full_send_dict,\
            number_of_full_nodes, number_of_full_triangles, \
-           s2p_map, p2s_map, tri_map, node_map, ghost_layer_width
-    
-
-
-def extract_l2g_map(map):
-    # Extract l2g data  from corresponding map
-    # Maps
-
-    import numpy as num
-    
-    # FIXME: this is where we loss the original order of 
-    # sequential domain
-    b = num.arange(len(map))
-
-    l_ids = num.extract(map>-1,map)
-    g_ids = num.extract(map>-1,b)
-
-#    print len(g_ids)
-#    print len(l_ids)
-#    print l_ids
-
-    l2g = num.zeros_like(g_ids)
-    l2g[l_ids] = g_ids
-
-    return l2g
-
+           s2p_map, p2s_map, tri_map, node_map, tri_l2g, node_l2g, \
+           ghost_layer_width
+    
+
+
+## def extract_l2g_map(map):
+##     # Extract l2g data  from corresponding map
+##     # Maps
+
+##     import numpy as num
+    
+##     # FIXME: this is where we loss the original order of 
+##     # sequential domain
+##     b = num.arange(len(map))
+
+##     l_ids = num.extract(map>-1,map)
+##     g_ids = num.extract(map>-1,b)
+
+## #    print len(g_ids)
+## #    print len(l_ids)
+## #    print l_ids
+
+##     l2g = num.zeros_like(g_ids)
+##     l2g[l_ids] = g_ids
+
+##     return l2g
+
Index: /trunk/anuga_core/source/anuga_parallel/sequential_distribute.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/sequential_distribute.py	(revision 9173)
+++ /trunk/anuga_core/source/anuga_parallel/sequential_distribute.py	(revision 9174)
@@ -18,94 +18,140 @@
 
 
-def sequential_distribute_dump(domain, numprocs=1, verbose=False, debug=False, parameters = None):
-    """ Distribute the domain, create parallel domain and pickle result
-    """
-
-
-    if debug:
-        verbose = True
-
-
-
-    # FIXME: Dummy assignment (until boundaries are refactored to
-    # be independent of domains until they are applied)
-    bdmap = {}
-    for tag in domain.get_boundary_tags():
-        bdmap[tag] = None
-
-    domain.set_boundary(bdmap)
-
-
-    domain_name = domain.get_name()
-    domain_dir = domain.get_datadir()
-    domain_store = domain.get_store()
-    domain_minimum_storable_height = domain.minimum_storable_height
-    domain_flow_algorithm = domain.get_flow_algorithm()
-    domain_minimum_allowed_height = domain.get_minimum_allowed_height()
-    georef = domain.geo_reference
-    number_of_global_triangles = domain.number_of_triangles
-    number_of_global_nodes = domain.number_of_nodes
-    boundary_map = domain.boundary_map
-
-
-    #sequential_distribute_mesh(domain, numprocs, verbose=verbose, debug=debug, parameters=parameters)
-
-
-    # Subdivide the mesh
-    if verbose: print 'sequential_distribute: Subdivide mesh'
-    new_nodes, new_triangles, new_boundary, triangles_per_proc, quantities, \
-           s2p_map, p2s_map = \
-           pmesh_divide_metis_with_map(domain, numprocs)
-
-    #PETE: s2p_map (maps serial domain triangles to parallel domain triangles)
-    #      sp2_map (maps parallel domain triangles to domain triangles)
-
-
-
-    # Build the mesh that should be assigned to each processor,
-    # this includes ghost nodes and the communication pattern
-    if verbose: print 'sequential_distribute: Build submeshes'
-    submesh = build_submesh(new_nodes, new_triangles, new_boundary, quantities, triangles_per_proc, parameters)
-
-    if debug:
-        for p in range(numprocs):
-            N = len(submesh['ghost_nodes'][p])
-            M = len(submesh['ghost_triangles'][p])
-            print 'There are %d ghost nodes and %d ghost triangles on proc %d'\
-                  %(N, M, p)
-
-    #if debug:
-    #    from pprint import pprint
-    #    pprint(submesh)
-
-
-    # extract data to create parallel domain
-    if verbose: print 'sequential_distribute: Distribute submeshes'
-    for p in range(0, numprocs):
-
-        # Build the local mesh for processor 0
+class Sequential_distribute(object):
+
+    def __init__(self, domain, verbose=False, debug=False, parameters=None):
+
+        if debug:
+            verbose = True
+            
+        self.domain = domain
+        self.verbose = verbose
+        self.debug = debug
+        self.parameters = parameters
+
+
+    def distribute(self, numprocs=1):
+
+        self.numprocs = numprocs
+        
+        domain = self.domain
+        verbose = self.verbose
+        debug = self.debug
+        parameters = self.parameters
+
+        # FIXME: Dummy assignment (until boundaries are refactored to
+        # be independent of domains until they are applied)
+        bdmap = {}
+        for tag in domain.get_boundary_tags():
+            bdmap[tag] = None
+
+        domain.set_boundary(bdmap)
+
+
+        self.domain_name = domain.get_name()
+        self.domain_dir = domain.get_datadir()
+        self.domain_store = domain.get_store()
+        self.domain_store_centroids = domain.get_store_centroids()
+        self.domain_minimum_storable_height = domain.minimum_storable_height
+        self.domain_flow_algorithm = domain.get_flow_algorithm()
+        self.domain_minimum_allowed_height = domain.get_minimum_allowed_height()
+        self.domain_georef = domain.geo_reference
+        self.number_of_global_triangles = domain.number_of_triangles
+        self.number_of_global_nodes = domain.number_of_nodes
+        self.boundary_map = domain.boundary_map
+
+
+        # Subdivide the mesh
+        if verbose: print 'sequential_distribute: Subdivide mesh'
+
+        new_nodes, new_triangles, new_boundary, triangles_per_proc, quantities, \
+               s2p_map, p2s_map = \
+               pmesh_divide_metis_with_map(domain, numprocs)
+
+
+        # Build the mesh that should be assigned to each processor,
+        # this includes ghost nodes and the communication pattern
+        if verbose: print 'sequential_distribute: Build submeshes'
+        if verbose: print parameters
+
+        submesh = build_submesh(new_nodes, new_triangles, new_boundary, \
+                                quantities, triangles_per_proc, parameters=parameters)
+
+        if verbose:
+            for p in range(numprocs):
+                N = len(submesh['ghost_nodes'][p])
+                M = len(submesh['ghost_triangles'][p])
+                print 'There are %d ghost nodes and %d ghost triangles on proc %d'\
+                      %(N, M, p)
+
+
+        self.submesh = submesh
+        self.triangles_per_proc = triangles_per_proc
+        self.p2s_map =  p2s_map
+
+
+    def extract_submesh(self, p=0):
+        """Build the local mesh for processor p
+        """
+
+        submesh = self.submesh
+        triangles_per_proc = self.triangles_per_proc 
+        p2s_map = self.p2s_map
+        verbose = self.verbose
+        debug = self.debug
+
+        assert p>=0
+        assert p<self.numprocs
+        
+        
         points, vertices, boundary, quantities, \
-            ghost_recv_dict, full_send_dict, tri_map, node_map, ghost_layer_width =\
-              extract_submesh(submesh, triangles_per_proc, p)
-
-
-#        from pprint import pprint
-#        print '='*80
-#        print p
-#        print '='*80
-#        pprint(tri_map)
-#        print len(tri_map)
-
-        # Keep track of the number full nodes and triangles.
-        # This is useful later if one needs access to a ghost-free domain
-        # Here, we do it for process 0. The others are done in rec_submesh.
+            ghost_recv_dict, full_send_dict, \
+            tri_map, node_map, tri_l2g, node_l2g, ghost_layer_width =\
+              extract_submesh(submesh, triangles_per_proc, p2s_map, p)
+              
+
         number_of_full_nodes = len(submesh['full_nodes'][p])
         number_of_full_triangles = len(submesh['full_triangles'][p])
 
-        # Extract l2g maps
-        tri_l2g  = extract_l2g_map(tri_map)
-        node_l2g = extract_l2g_map(node_map)
-
-
+
+        if debug:
+            import pprint
+            print  50*"="
+            print 'NODE_L2G'
+            pprint.pprint(node_l2g)
+        
+            pprint.pprint(node_l2g[vertices[:,0]])
+        
+            print 'VERTICES'
+            pprint.pprint(vertices[:,0])
+            pprint.pprint(new_triangles[tri_l2g,0])
+        
+            assert num.allclose(node_l2g[vertices[:,0]], new_triangles[tri_l2g,0])        
+            assert num.allclose(node_l2g[vertices[:,1]], new_triangles[tri_l2g,1]) 
+            assert num.allclose(node_l2g[vertices[:,2]], new_triangles[tri_l2g,2]) 
+        
+
+            print 'POINTS'
+            pprint.pprint(points)
+        
+            assert num.allclose(points[:,0], new_nodes[node_l2g,0])
+            assert num.allclose(points[:,1], new_nodes[node_l2g,1])
+
+
+            print 'TRI'
+            pprint.pprint(tri_l2g)
+            pprint.pprint(p2s_map[tri_l2g])
+        
+
+            assert num.allclose(original_triangles[tri_l2orig,0],node_l2g[vertices[:,0]])
+            assert num.allclose(original_triangles[tri_l2orig,1],node_l2g[vertices[:,1]])
+            assert num.allclose(original_triangles[tri_l2orig,2],node_l2g[vertices[:,2]])
+
+            print 'NODES'
+            pprint.pprint(node_map)
+            pprint.pprint(node_l2g)      
+        
+        #tri_l2orig = p2s_map[tri_l2g]        
+        
         s2p_map = None
         p2s_map = None
@@ -118,6 +164,4 @@
             print 'sequential_distribute: P%g, no_full_nodes = %g, no_full_triangles = %g' % (p, number_of_full_nodes, number_of_full_triangles)
 
-
-        #args = [points, vertices, boundary]
 
         kwargs = {'full_send_dict': full_send_dict,
@@ -125,9 +169,9 @@
                 'number_of_full_nodes': number_of_full_nodes,
                 'number_of_full_triangles': number_of_full_triangles,
-                'geo_reference': georef,
-                'number_of_global_triangles':  number_of_global_triangles,
-                'number_of_global_nodes':  number_of_global_nodes,
+                'geo_reference': self.domain_georef,
+                'number_of_global_triangles':  self.number_of_global_triangles,
+                'number_of_global_nodes':  self.number_of_global_nodes,
                 'processor':  p,
-                'numproc':  numprocs,
+                'numproc':  self.numprocs,
                 's2p_map':  s2p_map,
                 'p2s_map':  p2s_map, ## jj added this
@@ -136,16 +180,47 @@
                 'ghost_layer_width':  ghost_layer_width}
 
-        #-----------------------------------------------------------------------
-        # Now let's store the data for a  parallel_domain via cPickle
-        #-----------------------------------------------------------------------
-
-        #Looks like we reduce storage by a factor of 4 by just
-        # storing the data to create the parallel_domain instead of pickling
-        # a created domain
+
+        boundary_map = self.boundary_map
+        domain_name = self.domain_name
+        domain_dir = self.domain_dir
+        domain_store = self.domain_store
+        domain_store_centroids = self.domain_store_centroids
+        domain_minimum_storable_height = self.domain_minimum_storable_height
+        domain_minimum_allowed_height = self.domain_minimum_allowed_height
+        domain_flow_algorithm = self.domain_flow_algorithm
+        domain_georef = self.domain_georef
+            
+        tostore = (kwargs, points, vertices, boundary, quantities, \
+                   boundary_map, \
+                   domain_name, domain_dir, domain_store, domain_store_centroids, \
+                   domain_minimum_storable_height, \
+                   domain_minimum_allowed_height, domain_flow_algorithm, \
+                   domain_georef)
+
+
+        return tostore
+
+
+
+                       
+
+    
+def sequential_distribute_dump(domain, numprocs=1, verbose=False, debug=False, parameters = None):
+    """ Distribute the domain, create parallel domain and pickle result
+    """
+
+
+    partition = Sequential_distribute(domain, verbose, debug, parameters)
+
+    partition.distribute(numprocs)
+
+    
+    for p in range(0, numprocs):
+
+        tostore = partition.extract_submesh(p) 
+
         import cPickle
-        pickle_name = domain_name + '_P%g_%g.pickle'% (numprocs,p)
+        pickle_name = partition.domain_name + '_P%g_%g.pickle'% (numprocs,p)
         f = file(pickle_name, 'wb')
-        tostore = (kwargs, points, vertices, boundary, quantities, boundary_map, domain_name, domain_dir, domain_store, domain_minimum_storable_height, \
-                   domain_minimum_allowed_height, domain_flow_algorithm, georef)
         cPickle.dump( tostore, f, protocol=cPickle.HIGHEST_PROTOCOL)
 
@@ -165,6 +240,9 @@
     pickle_name = filename+'_P%g_%g.pickle'% (numprocs,myid)
     f = file(pickle_name, 'rb')
-    kwargs, points, vertices, boundary, quantities, boundary_map, domain_name, domain_dir, domain_store, domain_minimum_storable_height, \
-                   domain_minimum_allowed_height, domain_flow_algorithm, georef = cPickle.load(f)
+
+    kwargs, points, vertices, boundary, quantities, boundary_map, \
+                   domain_name, domain_dir, domain_store, domain_store_centroids, \
+                   domain_minimum_storable_height, domain_minimum_allowed_height, \
+                   domain_flow_algorithm, georef = cPickle.load(f)
     f.close()
 
@@ -194,8 +272,9 @@
     parallel_domain.set_name(domain_name)
     parallel_domain.set_datadir(domain_dir)
+    parallel_domain.set_flow_algorithm(domain_flow_algorithm)
     parallel_domain.set_store(domain_store)
+    parallel_domain.set_store_centroids(domain_store_centroids)
     parallel_domain.set_minimum_storable_height(domain_minimum_storable_height)
     parallel_domain.set_minimum_allowed_height(domain_minimum_allowed_height)
-    parallel_domain.set_flow_algorithm(domain_flow_algorithm)
     parallel_domain.geo_reference = georef
 
@@ -203,28 +282,8 @@
     return parallel_domain
 
-def extract_l2g_map(map):
-    # Extract l2g data  from corresponding map
-    # Maps
-
-    import numpy as num
-
-    b = num.arange(len(map))
-
-    l_ids = num.extract(map>-1,map)
-    g_ids = num.extract(map>-1,b)
-
-
-#    print len(g_ids)
-#    print len(l_ids)
-#    print l_ids
-#    print g_ids
-
-    l2g = num.zeros_like(g_ids)
-    l2g[l_ids] = g_ids
-
-    return l2g
-
-
-
-
-
+
+
+
+
+
+
Index: /trunk/anuga_core/source/anuga_parallel/test_distribute_mesh.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/test_distribute_mesh.py	(revision 9173)
+++ /trunk/anuga_core/source/anuga_parallel/test_distribute_mesh.py	(revision 9174)
@@ -1502,7 +1502,7 @@
         # Now test the extract_submesh for the 3 processors
 
-        submesh_cell_0 = extract_submesh(submesh,triangles_per_proc,0)
-        submesh_cell_1 = extract_submesh(submesh,triangles_per_proc,1)
-        submesh_cell_2 = extract_submesh(submesh,triangles_per_proc,2)
+        submesh_cell_0 = extract_submesh(submesh,triangles_per_proc,p=0)
+        submesh_cell_1 = extract_submesh(submesh,triangles_per_proc,p=1)
+        submesh_cell_2 = extract_submesh(submesh,triangles_per_proc,p=2)
 
 
